<?php

add_filter( 'saturn_tables_menus', 'saturn_tables_menus_cars', 10, 1 );

function saturn_tables_menus_cars( $saturn_tables_menus ) {
	
	$saturn_tables_menus[]= array (
					'type' => 'list_table',
					'page_title' => __( 'Cars' ),
					'menu_title' => __( 'Cars' ),
					'capability' => 'edit_posts',
					'menu_slug' => 'saturn-tables-cars-table',
					'callable' => 'saturn_tables_cars_list_table_func',
					'icon_url' => '',
					'position' => '40'
			);
	
	$saturn_tables_menus[] = array(
					'type' => 'input_form',
					'parent_slug' => 'saturn-tables-cars-table',
					'page_title' => __( 'Add Car' ),
					'menu_title' => __( 'Add Car' ),
					'capability' => 'edit_posts',
					'menu_slug' => 'saturn-tables-cars-add-edit-car',
					'callable' => 'saturn_tables_cars_add_edit_car_func');

			
	$saturn_tables_menus[] = array(
					'type' => 'submenu',
					'parent_slug' => 'saturn-tables-cars-table',
					'page_title' => __( 'Cars Import' ),
					'menu_title' => __( 'Cars Import' ),
					'capability' => 'edit_posts',
					'menu_slug' => 'saturn-tables-cars-import-export',
					'callable' => 'saturn_tables_cars_import_export_func');
	
		
	return $saturn_tables_menus;

}

/*************************/
/* LIST TABLE DEFINITION */
/*************************/

/* SATURN TABLES LIST TABLE MENU CALLBACK */

function saturn_tables_cars_list_table_func($page = "", $item = array(), $page_number = 1) {
		
			/* STANDARD LIST TABLE DEFINITION VALUES */
			
			//you can write code in here, probably best to write as little as possible
			$add_new_link =  admin_url("/admin.php/?page=saturn-tables-cars-add-edit-car&id=0");			
			$list_table_definitions['menu_title'] = '<h1 class="wp-heading-inline">View Cars</h1><a href="' . $add_new_link . '" class="page-title-action">Add New</a>';
	
			$list_table_definitions['notices'] = 'saturn_tables_cars_admin_notices';
	
			$list_table_definitions['header'] = '<p>The cars database is a short list of car information.</p>';			
			
			$list_table_definitions['columns'] = array('cb' => '<input type="checkbox" />', 'make' => "Make", 'model' => "Model", 'mpg' => "MPG", 'cylinders' => "Cylinders", 'weight' => "Weight", 'model_year' => "Model Year", 'country' => "Country"); 	
			
			$list_table_definitions['get_data'] = 'saturn_tables_cars_return_items';
			
			$list_table_definitions['get_data_count'] = 'saturn_tables_cars_return_items_count';
			
			/* LIST TABLE ACTION DEFINITION VALUES */
			
			$list_table_definitions['column_markup'] = call_user_func('saturn_tables_cars_list_table_markup', $page, $item, $page_number);
						
			$list_table_definitions['link_actions'] = call_user_func('saturn_tables_cars_list_table_actions', $page, $item, $page_number);
			
			$list_table_definitions['process_link_actions'] = 'saturn_tables_cars_process_link_actions';
			
			$list_table_definitions['checkbox_id'] = 'id';
			
			$list_table_definitions['bulk_actions'] = isset($_GET['status']) && ($_GET['status'] == "trash") ? array( 'bulk_delete' => 'Delete' ) : array( 'bulk_trash' => 'Trash' );
			
			$list_table_definitions['process_bulk_actions'] = 'saturn_tables_cars_process_bulk_actions';
			
			/* EXTRA LIST TABLE DEFINITION VALUES */
			
			$list_table_definitions['views'] = call_user_func("saturn_tables_cars_views");
			
			$list_table_definitions['search'] = array('label'=> "Search Make and Model", 'id' => "search_id");
			
			$list_table_definitions['extra_navigation'] = "saturn_tables_cars_make_dropdown";
			
			$list_table_definitions['filter_button'] = array('text' => "Filter By Make");
			
			$list_table_definitions['sortable'] = array( 'make' => array( 'make', true ), 'model' => array( 'model', false ) );
					
			$list_table_definitions['footer'] = '<p>Powered by <a href="https://saturntables.com/" target="_blank">Saturn Tables</a></p>';
			
	return $list_table_definitions;
	
}

/* LIST TABLE CALLABLE FUNCTIONS */

function saturn_tables_cars_admin_notices( ) {
    
    if (isset($_GET['delete']) && ($model = $_GET['delete']) ) {
		echo '<div class="notice notice-success is-dismissible"><p>' . __( "Model $model has been deleted." ) . '</p></div>';
	} elseif (isset($_GET['restore']) && ($model = $_GET['restore']) ) {
		echo '<div class="notice notice-success is-dismissible"><p>' . __( "Model $model has been restored." ) . '</p></div>';
    } elseif (isset($_GET['trash']) && ($model = $_GET['trash'])) {
		echo '<div class="notice notice-success is-dismissible"><p>' . __( "Model $model has been placed in the trash." ) . '</p></div>';
    } elseif (isset($_GET['bulk']) && ($bulk = $_GET['bulk']) == 'trash') {
	$count = $_GET['count'];
		echo '<div class="notice notice-success is-dismissible"><p>' . __( "$count item(s) have been placed in the trash." ) . '</p></div>';
    }  elseif (isset($_GET['bulk']) && ($bulk = $_GET['bulk']) == 'delete') {
	$count = $_GET['count'];
		echo '<div class="notice notice-success is-dismissible"><p>' . __( "$count item(s) have been deleted." ) . '</p></div>';
    }    
}

function saturn_tables_cars_return_items ($per_page, $page_number) {
	
	global $wpdb;
	
	$offset = ($per_page * ($page_number -1));
	
	$orderby_clause = "";
	if (isset($_GET['orderby']) && isset($_GET['order'])) {
		$orderby = esc_sql($_GET['orderby']);
		$order = esc_sql($_GET['order']);
		$orderby_clause = "ORDER BY $orderby $order";
	}
	
	$where_clause[] =  1;
	if (isset($_GET['status'])) {
		$status = ($_GET['status'] == "trash") ? 1 : 0;
		$where_clause[] =  "status = $status";
	} else {
		$where_clause[] =  "status = 0";
	}
	if (isset($_GET['s'])) {
		$search = esc_sql($_GET['s']);
		$where_clause[] =  "CONCAT_WS(' ', make, model) LIKE '%$search%'";
	}
	if (isset($_GET['make'])) {
		$make = esc_sql($_GET['make']);
		$where_clause[] =  ($make == "All Makes") ? 1 : "make = '$make'";
	}
	$where_clause = implode(" AND ", $where_clause);
	
	$query = "SELECT id, make, model, mpg, cylinders, weight, model_year, country FROM saturn_tables_cars WHERE $where_clause $orderby_clause LIMIT $per_page OFFSET $offset";
	if ($wpdb->get_var("SHOW TABLES LIKE 'saturn_tables_cars'")) { 
		$items = $wpdb->get_results($query, ARRAY_A);
		return $items;
	}	
}
	

function saturn_tables_cars_return_items_count() {
	
	global $wpdb;
	
	$where_clause[] =  1;
	if (isset($_GET['status'])) {
		$status = ($_GET['status'] == "trash") ? 1 : 0;
		$where_clause[] =  "status = $status";
	}
	if (isset($_GET['s'])) {
		$search = esc_sql($_GET['s']);
		$where_clause[] =  "CONCAT_WS(' ', make, model) LIKE '%$search%'";
	}
	if (isset($_GET['make'])) {
		$make = esc_sql($_GET['make']);
		$where_clause[] =  ($make == "All Makes") ? 1 : "make = '$make'";
	}
	$where_clause = implode(" AND ", $where_clause);
	
		
	$query = "SELECT count(*) FROM saturn_tables_cars WHERE $where_clause";
	
	if ($wpdb->get_var("SHOW TABLES LIKE 'saturn_tables_cars'")) {
		return $wpdb->get_var($query);
	}
	
}

function saturn_tables_cars_list_table_markup($page, $item, $page_number) {
	
	$item_id = (isset($item['id']) && ((int)$item['id'] > 0)) ? $item['id'] : 0;
	$make = (isset($item['make'])) ? $item['make'] : "";

	return array('make' => sprintf('<strong><a href="?page=%s&id=%d">%s</a></strong>', 'saturn-tables-cars-add-edit-car', $item_id,  $make ) );

}

function saturn_tables_cars_list_table_actions ( $page, $item, $page_number) {
	
	$item_id = (isset($item['id']) && ((int)$item['id'] > 0)) ? $item['id'] : 0;
			
	if (isset($_GET['status']) && ($_GET['status'] == "trash")) {
			$links = array( 'make' => array('delete' => sprintf( '<a href="?page=%s&delete_id=%d&paged=%d">Delete Permanently</a>', $page, $item_id, $page_number ),
											'restore' => sprintf( '<a href="?page=%s&restore_id=%d&paged=%d">Restore</a>', $page, $item_id, $page_number )));

	} else {
			$links = array( 'make' => array('trash' => sprintf( '<a href="?page=%s&trash_id=%d&paged=%d">Trash</a>', $page, $item_id , $page_number ),
											'edit' => sprintf( '<a href="?page=%s&id=%d">Edit</a>', 'saturn-tables-cars-add-edit-car', $item_id ) ) );

	}
	return $links;
}


function saturn_tables_cars_process_link_actions() {
	
	global $wpdb;
		
	if ( (isset($_GET['delete_id']) &&  $delete_id = (int)$_GET['delete_id']) > 0) {
		
		$model = $wpdb->get_var("SELECT model FROM saturn_tables_cars WHERE id = $delete_id");
		$wpdb->delete( 'saturn_tables_cars', array('id' => $delete_id),  array('id' => '%d'));
		
		//redirect without delete_id
		parse_str($_SERVER['QUERY_STRING'], $query_string);
		unset($query_string['delete_id']);
		$query_string['delete'] = $model;
		$query_string['status'] = "trash";
		$redirect = admin_url() . "?" . http_build_query($query_string);
		wp_redirect( $redirect );		
		exit;
	} 
	elseif ( isset($_GET['trash_id']) && ($trash_id = (int)$_GET['trash_id']) > 0) {
		
		$model = $wpdb->get_var("SELECT model FROM saturn_tables_cars WHERE id = $trash_id");
		$wpdb->update( 'saturn_tables_cars',  array('status' => 1), array('id' => $trash_id),  array('%d'),  array('%d') );
		
		//redirect without trash_id
		parse_str($_SERVER['QUERY_STRING'], $query_string);
		unset($query_string['trash_id']);
		$query_string['trash'] = $model;
		$redirect = admin_url() . "?" . http_build_query($query_string);
		wp_redirect( $redirect );		
		exit;
	}
	elseif ( isset($_GET['restore_id']) && ($restore_id = (int)$_GET['restore_id']) > 0) {
		
		$model = $wpdb->get_var("SELECT model FROM saturn_tables_cars WHERE id = $restore_id");
		$wpdb->update( 'saturn_tables_cars',  array('status' => 0), array('id' => $restore_id),  array('%d'),  array('%d') );
		
		//redirect without trash_id
		parse_str($_SERVER['QUERY_STRING'], $query_string);
		unset($query_string['restore_id']);
		$query_string['restore'] = $model;
		$query_string['status'] = "trash";
		$redirect = admin_url() . "?" . http_build_query($query_string);
		wp_redirect( $redirect );		
		exit;
	} 
}

function saturn_tables_cars_process_bulk_actions() {
	
	global $wpdb;
	
	if (isset($_GET['action']) && ($_GET['action'] == 'bulk_trash') || (isset($_GET['action2']) && ($_GET['action2'] == 'bulk_trash' ))) {		
		
		$trash_ids = esc_sql( $_GET['cb'] );
		
		$count =  0;		
		foreach ($trash_ids as $id) {
			$affected = $wpdb->update( 'saturn_tables_cars',  array('status' => 1), array('id' => $id),  array('%d'),  array('%d') );
			$count += $affected;
		}
		
		parse_str($_SERVER['QUERY_STRING'], $query_string);
		unset($query_string['action'],$query_string['action2']);
		$query_string['bulk'] = "trash";
		$query_string['count'] = $count;
		$redirect = admin_url() . "?" . http_build_query($query_string);
		wp_redirect( $redirect );		
		exit;
		
	} elseif (isset($_GET['action']) && ($_GET['action'] == 'bulk_delete') || (isset($_GET['action2']) && ($_GET['action2'] == 'bulk_delete' ))) {
		
		$delete_ids = esc_sql( $_GET['cb'] );
		
		$count =  0;		
		foreach ($delete_ids as $id) {
			$affected = $wpdb->delete( 'saturn_tables_cars', array('id' => $id),  array('id' => '%d'));;
			$count += $affected;
		}
		
		parse_str($_SERVER['QUERY_STRING'], $query_string);
		unset($query_string['action'],$query_string['action2']);
		$query_string['bulk'] = "delete";
		$query_string['status'] = "trash";
		$query_string['count'] = $count;
		$redirect = admin_url() . "?" . http_build_query($query_string);
		wp_redirect( $redirect );		
		exit;
	}
}

function saturn_tables_cars_views() {
	
	if (isset($_GET['status']) && $_GET['status'] == "trash") {
		$all = '<a href="' . admin_url("admin.php?page=saturn-tables-cars-table&status=all") . '">' . __("All") . '</a>';
		$trash = '<strong>' . __("Trash") . '</strong>';
	} else {
		$all = '<strong>' . __("All") . '</strong>';
		$trash = '<a href="' . admin_url("admin.php?page=saturn-tables-cars-table&status=trash") . '">' . __("Trash") . '</a>';	
	}
	
	return array( "all" => $all, "trash" => $trash);
}

function saturn_tables_cars_make_dropdown() {
	
	global $wpdb;
	
	if ($wpdb->get_var("SHOW TABLES LIKE 'saturn_tables_cars'")) { 
		$makes = $wpdb->get_col( "SELECT DISTINCT make FROM saturn_tables_cars ORDER BY make" );
	} else {
		$makes = array();
	}
	
	$output = '<label for="filter-by-make" class="screen-reader-text">Filter by Make</label>';	
	$output .= '<select name="make" id="filter-by-make">';
	$output .= '<option>All Makes</option>';
	foreach ($makes as $make) {
		$selected = (isset($_GET['make']) && ($make == $_GET['make'])) ? " selected" : "";
		$output .= "<option$selected>" . esc_html($make) ."</option>";
	}
	$output .= '</select>';
	
	return $output;
}

/* END LIST TABLE CALLABLE FUNCTIONS */

/*************************/
/* INPUT FORM DEFINITION */
/*************************/

/* SATURN TABLES INPUT FORM MENU CALLBACK */

function saturn_tables_cars_add_edit_car_func() {
	
	$id = isset($_GET['id']) ? $_GET['id'] : 0;
	$input_form_definitions['menu_title'] = $id ? '<h1  class="wp-heading-inline">Edit Car</h1> <strong>[ID:' . $id . ']</strong>' : '<h1>Add Car</h1>';
	$input_form_definitions['header'] = $id ? '<p>Edit car below with this form.</p>' : '<p>Input new car with this form.</p>';
	$input_form_definitions['form_definition'] = 'saturn_tables_cars_input_form_definition';
	$input_form_definitions['get_post_vars'] = 'saturn_tables_cars_get_post_vars';
	$input_form_definitions['run_query'] = 'saturn_tables_cars_run_query';
	$input_form_definitions['process_post_vars'] = 'saturn_tables_cars_process_post_vars';
	$input_form_definitions['set_notices'] = 'saturn_tables_cars_set_notices';
	$input_form_definitions['submit_button'] = $id ? array('text' => "Edit") : array('text' => "Input");
	$input_form_definitions['footer'] = '<p>Powered by <a href="https://saturntables.com/" target="_blank">Saturn Tables</a></p>';	
	
	return $input_form_definitions;
}

/* INPUT FORM CALLABLE FUNCTIONS */

function saturn_tables_cars_input_form_definition() {
	
	global $wpdb;
	
	if ($wpdb->get_var("SHOW TABLES LIKE 'saturn_tables_cars'")) {;
		$countries = $wpdb->get_col( "SELECT DISTINCT country FROM saturn_tables_cars ORDER BY country" );
	} else {
		$countries = array();
	}
	
	$input_form['make'] = array('label'=> "Make", "required" => "", 'type'=>"text" );
	$input_form['model'] = array( 'label'=> "Model", "required" => "", 'type'=>"textarea", 'rows'=>"5", 'cols'=>"30", 'style'=>"max-width: 500px;");
	$input_form['mpg'] = array ('label'=> "MPG", "required" => "", 'type' => "number", 'step'=>".1");
	$input_form['cylinders'] = array ('label'=> "Cylinders", "required" => "", 'type' => "number", 'step'=>"1");
	$input_form['weight'] = array ('label'=> "Weight", "required" => "", 'type' => "number", 'step'=>"1");
	$input_form['model_year'] = array ('label'=> "Model Year", "required" => "", 'type' => "number", 'step'=>"1");
	$input_form['country'] = array ('label'=> "Country", "required" => "", 'type' => "select", 'options' => $countries , 'usekey' => false);
	
	return $input_form;
	
}

function saturn_tables_cars_get_post_vars($input_form, $query_return, $notices, $post_vars) {
	
		//get everything into a var
		if (!empty($input_form)) {
			foreach ($input_form as $key => $value) {
				if (isset($_POST[$key]))
					$post_vars[$key] = sanitize_text_field(stripslashes_deep($_POST[$key]));
			}
		}
		if (isset($_POST['submit'])) {
			$post_vars['submit'] = sanitize_text_field(stripslashes_deep($_POST['submit']));
		}
		
		return $post_vars;
		
	}	
	

function saturn_tables_cars_run_query($input_form, $query_return) {
	
	global $wpdb;
	
	if (isset($_POST['submit'])) {
	
		$id = isset($_GET['id']) ? (int)$_GET['id'] : 0;
		
		foreach ($input_form as $key => $value) {
			if (isset($_POST[$key]))
					$post_vars[$key] = sanitize_text_field($_POST[$key]);
			}

		
		if ($id == 0) {
			 //insert new row
			 $data = array('make' => $post_vars['make'], 'model' => $post_vars['model'], 'mpg' => $post_vars['mpg'], 'cylinders' => $post_vars['cylinders'], 'weight' => $post_vars['weight'], 'model_year' => $post_vars['model_year'], 'country' => $post_vars['country']);
			 $formats = array('%s','%s','%f','%d','%d','%d','%s');
			 if (count($wpdb->get_var("SHOW TABLES LIKE 'saturn_tables_cars'"))) {
				$query_return = $wpdb->insert('saturn_tables_cars', $data, $formats);
				return false;
			 }			 
			 
		} elseif ($id > 0) {
			//update row
			$data = array('make' => $post_vars['make'], 'model' => $post_vars['model'], 'mpg' => $post_vars['mpg'], 'cylinders' => $post_vars['cylinders'], 'weight' => $post_vars['weight'], 'model_year' => $post_vars['model_year'], 'country' => $post_vars['country']);
			$where = array('id' => $id);				
			$data_formats =  $formats = array('%s','%s','%f','%d','%d','%d','%s');				
			$where_formats = array('%d');
			if (count($wpdb->get_var("SHOW TABLES LIKE 'saturn_tables_cars'"))) {
				$query_return = $wpdb->update('saturn_tables_cars', $data, $where, $data_formats, $where_formats );			
				return false;
			}
		}		
	}	
}

function saturn_tables_cars_set_notices($input_form, $query_return, $notices) {
	
	if (isset($_POST['submit'])) {
	
		$id = isset($_GET['id']) ? (int)$_GET['id'] : 0;
	
		if ((!$id) && $query_return) {
			$notices[] = '<div class="notice notice-error is-dismissible"><p>' . __("There was a problem with the record insert.") . '</p></div>';			
		} elseif (($id) && $query_return) {			
			$notices[] = '<div class="notice notice-error is-dismissible"><p>' . __("There was a problem with the record update.") . '</p></div>';			
		} elseif ((!$id) && !$query_return) {			
			$notices[] = '<div class="notice notice-success is-dismissible"><p>' . __("A record was inserted.") . '</p></div>';			
		} elseif ($id && !$query_return) {
			$notices[] = '<div class="notice notice-success is-dismissible"><p>' . __("Record updated.") . '</p></div>';			
		}	
	}
	
	return $notices;
}

function saturn_tables_cars_process_post_vars($input_form, $query_return, $post_vars) {
	
	global $wpdb;
	
	$id = isset($_GET['id']) ? (int)$_GET['id'] : 0;
	
	if (!$id && !$query_return) {
		 //insert
		 $post_vars = array();		 
	} elseif ($id) {
		//update
		if (count($wpdb->get_var("SHOW TABLES LIKE 'saturn_tables_cars'"))) {
			$post_vars = $wpdb->get_row($wpdb->prepare("SELECT id, make, model, mpg, cylinders, weight, model_year, country FROM saturn_tables_cars WHERE id = %d", $id), ARRAY_A);		
		}
	}
	
	return $post_vars;
}

/* END INPUT FORM CALLABLE FUNCTIONS */

function saturn_tables_cars_import_export_func() {
	
	global $wpdb;
	
	if (isset($_POST['create_table']) && ($_POST['create_table'] == "Create Cars Data Table")) {
		
		if (is_uploaded_file($_FILES['cars_data']["tmp_name"])) {
			
			$query =    "DROP TABLE IF EXISTS `saturn_tables_cars`;";
			$wpdb->query($query);
			
			$query =    "CREATE TABLE `saturn_tables_cars` (
						`id` int(11) NOT NULL AUTO_INCREMENT,
						`make` tinytext NOT NULL,
						`model` tinytext NOT NULL,
						`mpg` decimal(6,1) NOT NULL,
						`cylinders` int(11) NOT NULL,
						`weight` int(11) NOT NULL,
						`model_year` int(11) NOT NULL,
						`country` tinytext NOT NULL,
						`status` int(11) NOT NULL DEFAULT '0',
						PRIMARY KEY (`id`)
					   ) ENGINE=InnoDB AUTO_INCREMENT=424 DEFAULT CHARSET=utf8mb4;";
			$table_created = $wpdb->query($query);
			
			$handle = fopen($_FILES['cars_data']["tmp_name"], "rb");
			
			if ($handle) {
				
				if (!feof($handle))
					$header = str_getcsv(fgets($handle));
				
				while (!feof($handle) ) {
				
					$line = fgets($handle);
					$arr = array_combine($header, str_getcsv($line));
					$result = $wpdb->insert('saturn_tables_cars', $arr);
				}
				
			}
			
			fclose($handle);
			$message =  __( "Table saturn_tables_cars has been created.");
					
		}
	}
		
	elseif (isset($_POST['delete_table']) && ($_POST['delete_table'] == "Delete Cars Data Table")) {
		
			$query = "DROP TABLE IF EXISTS `saturn_tables_cars`;";
			$wpdb->query($query);
			
			$message = "Table saturn_tables_cars has been dropped.";
	}	
?>



<div class="wrap">
	
<h1>Cars Dataset Function</h1>

<?php if (isset($message) && is_string($message)) echo '<div class="notice notice-success is-dismissible"><p>' . $message . '</p></div>'; ?>
	
<form method="post" action="<?php echo $_SERVER['REQUEST_URI']; ?>" enctype='multipart/form-data'>

<div style="padding: 20px 20px 30px; border: 1px solid #CCCCCC; margin: 10px 0; display: table-cell;">
<p>Load the Cars dataset (saturn_tables_cars_data.csv) and create the saturn_tables_cars data table.</p>
<input type="file" name="cars_data" />
<?php submit_button("Create Cars Data Table", "button", "create_table", false); ?>
</div><br>
<div style="padding: 20px 20px 30px; border: 1px solid #CCCCCC; margin: 10px 0; display: table-cell;">
<p>Delete the Cars table when finished with the example.</p>
<?php submit_button("Delete Cars Data Table", "button", "delete_table", false); ?>
</div><br>
<div style="padding: 20px 20px 30px; border: 1px solid #CCCCCC; margin: 10px 0; display: table-cell;">
<p>Example file download exporting the Cars dataset.</p>
<p><a class="button" href="<?php echo admin_url( 'admin.php?page=saturn-tables-cars-import-export&download=cars') ?>">Export Cars Data</a></p>
</div>
</form>

</div>
<?php
}


add_action('wp_loaded','saturn_tables_cars_download_cars_func');

function saturn_tables_cars_download_cars_func() {
	
	global $pagenow;
	global $wpdb;
	 
    if ($pagenow=='admin.php' && current_user_can('manage_options')
		&& isset($_GET['download'])  && $_GET['download']=='cars'
		&& isset($_GET['page'])  && $_GET['page']=='saturn-tables-cars-import-export') :
	
		header("Content-type: text/plain; charset=utf-8");
		header("Content-Disposition: attachment; filename=cars_dataset.csv");
		header("Pragma: no-cache");
		header("Expires: 0");
		
		$fp = fopen('php://output', 'w');
		
		$query = "SHOW COLUMNS FROM `saturn_tables_cars`";	
		$header = $wpdb->get_col($query);
		$wpdb->flush();
	
		fputcsv($fp, $header);
	
		$query = "SELECT * FROM `saturn_tables_cars`";	
		$results = $wpdb->get_results($query, ARRAY_A);
		$wpdb->flush();
		
		if(count($results) > 0 ) {        
			foreach($results AS $row){
				fputcsv($fp, $row);
			}        
		}
		
		fclose($fp);
		ob_flush();	
	
	exit();
	
	endif;

}

/* END EXTRA FUNCTIONS */
	
?>